'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
// Copyright (c) 2016 Uber Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
// in compliance with the License. You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software distributed under the License
// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing permissions and limitations under
// the License.

var _span = require('../span');

var _span2 = _interopRequireDefault(_span);

var _logger = require('../logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LoggingReporter = function () {
  function LoggingReporter(logger) {
    _classCallCheck(this, LoggingReporter);

    this._logger = logger || new _logger2.default();
  }

  _createClass(LoggingReporter, [{
    key: 'report',
    value: function report(span) {
      this._logger.info('Reporting span ' + span.context().toString());
    }
  }, {
    key: 'name',
    value: function name() {
      return 'LoggingReporter';
    }
  }, {
    key: 'toString',
    value: function toString() {
      return this.name();
    }
  }, {
    key: 'close',
    value: function close(callback) {
      if (callback) {
        callback();
      }
    }
  }, {
    key: 'setProcess',
    value: function setProcess(serviceName, tags) {}
  }]);

  return LoggingReporter;
}();

exports.default = LoggingReporter;
//# sourceMappingURL=logging_reporter.js.map